/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.2(1ebfb1b687c4345ac9c6da39051431a46c120a65)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/

define("vs/languages/css/common/cssWorker.nls.ja", {
	"vs/languages/css/common/cssWorker": [
		"@keyframes {0}",
		"@font-face",
		"名前を \'{0}\' に変更します",
	],
	"vs/languages/css/common/parser/cssErrors": [
		"数字が必要です",
		"条件が必要です",
		"@ 規則またはセレクターが必要です",
		"ドットが必要です",
		"コロンが必要です",
		"セミコロンが必要です",
		"用語が必要です",
		"式が必要です",
		"演算子が必要です",
		"識別子が必要です",
		"パーセンテージが必要です",
		"URI または文字列が必要です",
		"URI が必要です",
		"変数名が必要です",
		"変数値が必要です",
		"プロパティ値が必要です",
		"{ が必要です",
		"} が必要です",
		"[ が必要です",
		"] が必要です",
		"( が必要です",
		") が必要です",
		"コンマが必要です",
		"ページ ディレクティブまたは宣言が必要です",
		"不明な @ 規則",
		"不明なキーワード",
		"セレクターが必要です",
		"リテラル文字列が必要です",
	],
	"vs/languages/css/common/services/intelliSense": [
		"赤、緑、青の値を指定して色を作成します。",
		"赤、緑、青の値とアルファ値を指定して色を作成します。",
		"色合い、鮮やかさ、明るさを指定して色を作成します。",
		"色合い、鮮やかさ、明るさ、アルファ値を指定して色を作成します。",
	],
	"vs/languages/css/common/services/lint": [
		"\'{0}\'",
		"{0}、\'{1}\'",
		"キーフレームを定義する場合は常に標準の規則 \'@keyframes\' を定義します。",
		"常にベンダー固有の規則をすべて含めます: 不足: {0}",
		"互換性のために標準のプロパティ \'{0}\' も定義します",
		"常にベンダー固有のプロパティをすべて含めます: 不足: {0}",
	],
	"vs/languages/css/common/services/lintRules": [
		"ベンダー固有のプレフィックスを使用する場合は、他のすべてのベンダー固有のプロパティも必ず含めてください",
		"ベンダー固有のプレフィックスを使用する場合は、標準のプロパティも含めます",
		"重複するスタイル定義を使用しないでください",
		"空の規則セットを使用しないでください",
		"複数の Import ステートメントを同時に読み込むことはできません",
		"パディングまたは枠線を使用する場合は幅または高さを使用しないでください",
		"ユニバーサル セレクター (*) を使用すると処理速度が低下することが分かっています",
		"0 の単位は必要ありません",
		"@font-face 規則で \'src\' プロパティと \'font-family\' プロパティを定義する必要があります",
		"16 進数の色には、3 つまたは 6 つの 16 進数が含まれる必要があります",
		"正しくないパラメーターの数",
		"不明なプロパティ。",
		"IE ハックは、IE7 以前をサポートする場合にのみ必要です",
		"不明なベンダー固有のプロパティ。",
		"表示によりプロパティが無視されます。たとえば、\'display: inline\' の場合、width、height、margin-top、margin-bottom、および float のプロパティには効果がありません",
		"!important は使用しないでください。これは CSS 全体の特定性が制御不能になり、リファクタリングが必要なことを示しています。",
		"\'float\' は使用しないでください。float を使用すると、レイアウトの一部が変更されたときに CSS が破損しやすくなります。",
		"セレクターには ID を含めないでください。これらの規則と HTML の結合が密接すぎます。",
		"すべての検証を有効または無効にします",
	]
});