/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.2(1ebfb1b687c4345ac9c6da39051431a46c120a65)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/

define("vs/languages/sass/common/sassWorker.nls.ko", {
	"vs/languages/sass/common/parser/sassErrors": [
		"\'from\'이 필요합니다.",
		"\'through\' 또는 \'to\'가 필요합니다.",
		"\'in\'이 필요합니다.",
	],
	"vs/languages/sass/common/services/intelliSense": [
		"색의 빨간색 구성 요소를 가져옵니다.",
		"색의 녹색 구성 요소를 가져옵니다.",
		"색의 파란색 구성 요소를 가져옵니다.",
		"두 색을 함께 혼합합니다.",
		"색의 색상 구성 요소를 가져옵니다.",
		"색의 채도 구성 요소를 가져옵니다.",
		"색의 명도 구성 요소를 가져옵니다.",
		"색의 색상을 변경합니다.",
		"색을 더 밝게 만듭니다.",
		"색을 더 어둡게 만듭니다.",
		"색을 더 높은 채도로 만듭니다.",
		"색을 더 낮은 채도로 만듭니다.",
		"색을 회색조로 변환합니다.",
		"색의 보수를 반환합니다.",
		"색의 역수를 반환합니다.",
		"색의 불투명도 구성 요소를 가져옵니다.",
		"색의 알파 구성 요소를 변경합니다.",
		"색을 더 불투명하게 만듭니다.",
		"색을 더 불투명하게 만듭니다.",
		"색을 더 투명하게 만듭니다.",
		"색의 여러 가지 구성 요소를 늘리거나 줄입니다.",
		"색의 여러 가지 속성을 유연하게 확장합니다.",
		"색의 여러 가지 속성을 변경합니다.",
		"색을 IE 필터에서 인식할 수 있는 형식으로 변환합니다.",
		"스타일시트에서 중첩된 것처럼 서로의 아래에 선택기를 중첩합니다.",
		"사이에 공백 없이 서로에 선택기를 추가합니다.",
		"$selector 내에서 $extender(으)로 $extendee을(를) 확장합니다.",
		"$selector 내에서 $original을(를) $replacement(으)로 바꿉니다.",
		"두 선택기를 통합하여 둘 다와 일치하는 요소와 일치하는 선택기를 생성합니다.",
		"$sub이(가) 일치하는 모든 요소와 $super이(가) 일치하는지 여부 등을 반환합니다.",
		"복합 선택기를 구성하는 간단한 선택기를 반환합니다.",
		"선택기를 &에서 반환된 형식으로 구문 분석합니다.",
		"문자열에서 따옴표를 제거합니다.",
		"문자열에 따옴표를 추가합니다.",
		"문자열에서 문자 수를 반환합니다.",
		"$insert을(를) $index의 $string에 삽입합니다.",
		"$string에서 처음으로 나타나는 $substring의 인덱스를 반환합니다.",
		"$string에서 부분 문자열을 추출합니다.",
		"문자열을 대문자로 변환합니다.",
		"문자열을 소문자로 변환합니다.",
		"단위 없는 숫자를 백분율로 변환합니다.",
		"숫자를 가장 가까운 정수로 반올림합니다.",
		"숫자를 다음 정수로 올림합니다.",
		"숫자를 이전 정수로 내림합니다.",
		"숫자의 절대 값을 반환합니다.",
		"여러 숫자의 최소값을 찾습니다.",
		"여러 숫자의 최대값을 찾습니다.",
		"난수를 반환합니다.",
		"목록의 길이를 반환합니다.",
		"목록의 특정 항목을 반환합니다.",
		"목록의 n번째 항목을 바꿉니다.",
		"두 목록을 하나로 함께 결합합니다.",
		"목록의 끝에 단일 값을 추가합니다.",
		"여러 목록을 단일 다차원 목록으로 결합합니다.",
		"목록 내에서 값의 위치를 반환합니다.",
		"목록의 구분 기호를 반환합니다.",
		"맵에서 지정된 키와 연결된 값을 반환합니다.",
		"두 맵을 새 맵으로 함께 병합합니다.",
		"키가 제거된 새 맵을 반환합니다.",
		"맵의 모든 키 목록을 반환합니다.",
		"맵의 모든 값 목록을 반환합니다.",
		"맵에 지정된 키와 연결된 값이 있는지 여부를 반환합니다.",
		"가변 인수를 사용하는 함수에 전달된 키워드를 반환합니다.",
		"현재 Sass 런타임에 기능이 있는지 여부를 반환합니다.",
		"지정된 이름의 변수가 현재 범위에 있는지 여부를 반환합니다.",
		"지정된 이름의 변수가 전역 범위에 있는지 여부를 반환합니다.",
		"지정된 이름의 함수가 있는지 여부를 반환합니다.",
		"지정된 이름의 mixin이 있는지 여부를 반환합니다.",
		"Sass로 표현되는 경우처럼 값의 문자열 표현을 반환합니다.",
		"값의 형식을 반환합니다.",
		"숫자와 연결된 단위를 반환합니다.",
		"숫자에 단위가 있는지 여부를 반환합니다.",
		"두 개의 숫자를 더하거나, 빼거나, 비교할 수 있는지 여부를 반환합니다.",
		"Sass 함수를 동적으로 호출합니다.",
	]
});