/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.2(1ebfb1b687c4345ac9c6da39051431a46c120a65)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var t=["vs/languages/css/common/cssTokenTypes","exports","require","vs/languages/css/common/css","vs/base/common/objects","vs/editor/common/modes","vs/platform/thread/common/threadService","vs/base/common/async","vs/editor/common/modes/abstractState","vs/platform/instantiation/common/instantiation","vs/platform/thread/common/thread","vs/editor/common/modes/languageConfigurationRegistry","vs/editor/common/modes/supports/tokenizationSupport","vs/editor/common/modes/abstractMode"],e=function(e){for(var n=[],r=0,o=e.length;o>r;r++)n[r]=t[e[r]];return n};define(t[0],e([2,1]),function(t,e){"use strict";e.TOKEN_SELECTOR="entity.name.selector",e.TOKEN_SELECTOR_TAG="entity.name.tag",e.TOKEN_PROPERTY="support.type.property-name",e.TOKEN_VALUE="support.property-value",e.TOKEN_AT_KEYWORD="keyword.control.at-rule"});var n=this&&this.__extends||function(t,e){function n(){this.constructor=t}for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r]);t.prototype=null===e?Object.create(e):(n.prototype=e.prototype,new n)},r=this&&this.__decorate||function(t,e,n,r){var o,i=arguments.length,s=3>i?e:null===r?r=Object.getOwnPropertyDescriptor(e,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(t,e,n,r);else for(var a=t.length-1;a>=0;a--)(o=t[a])&&(s=(3>i?o(s):i>3?o(e,n,s):o(e,n))||s);return i>3&&s&&Object.defineProperty(e,n,s),s},o=this&&this.__param||function(t,e){return function(n,r){e(n,r,t)}};define(t[3],e([2,1,4,5,6,0,13,8,9,10,11,12,7]),function(t,e,i,s,a,c,u,p,l,d,h,f,v){"use strict";e.cssTokenTypes=c,function(t){t[t.Selector=0]="Selector",t[t.Rule=1]="Rule",t[t.Value=2]="Value",t[t.ValuePostUrl=3]="ValuePostUrl",t[t.ValueInUrlFunction=4]="ValueInUrlFunction",t[t.Unit=5]="Unit",t[t.Meta=6]="Meta",t[t.MetaPostUrl=7]="MetaPostUrl",t[t.MetaInUrlFunction=8]="MetaInUrlFunction"}(e.States||(e.States={}));var m=e.States,g=/^-?-?([a-zA-Z]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))([\w\-]|(\\(([0-9a-fA-F]{1,6}\s?)|[^[0-9a-fA-F])))*/,y=function(t){function e(e,n,r,o,i,s){t.call(this,e),this.kind=n,this.inComment=r,this.quote=o,this.inMeta=i,this.metaBraceCount=s}return n(e,t),e.prototype.nextState=function(t,e){return this.kind=t,e},e.prototype.makeClone=function(){return new e(this.getMode(),this.kind,this.inComment,this.quote,this.inMeta,this.metaBraceCount)},e.prototype.equals=function(e){return t.prototype.equals.call(this,e)&&i.equals(this,e)},e.prototype.tokenizeInComment=function(t){return/\*\/$/.test(t.advanceUntilString("*/",!0))&&(this.inComment=!1),{type:"comment.css"}},e.prototype.tokenizeInString=function(t){for(var e,n=!1,r=this.quote;!t.eos();)if(e=t.next(),n)n=!1;else if("\\"===e)n=!0;else if(e===r){this.quote=null;break}return{type:"string.css"}},e.prototype.consumeIdent=function(t){return t.goBack(1),t.advanceIfRegExp2(g)?!0:(t.advance(1),!1)},e.prototype.tokenize=function(t){if(this.inComment)return this.tokenizeInComment(t);if(null!==this.quote)return this.tokenizeInString(t);if(t.skipWhitespace2())return{type:""};if(t.advanceIfString2("/*"))return this.inComment=!0,this.tokenizeInComment(t);if(t.advanceIfString2("'"))return this.quote="'",this.tokenizeInString(t);if(t.advanceIfString2('"'))return this.quote='"',this.tokenizeInString(t);var e=t.next();switch(this.kind){case m.ValuePostUrl:if("("===e)return this.nextState(m.ValueInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=m.Value;break;case m.MetaPostUrl:if("("===e)return this.nextState(m.MetaInUrlFunction,{type:"punctuation.parenthesis.css"});this.kind=m.Meta;break;case m.ValueInUrlFunction:case m.MetaInUrlFunction:if(")"!==e)return t.advanceIfRegExp2(/^[^\)]*/),{type:"string.css"};this.kind=this.kind===m.ValueInUrlFunction?m.Value:m.Meta}switch(this.kind){case m.Selector:return"{"===e?this.nextState(m.Rule,{type:"punctuation.bracket.css"}):"("===e||")"===e?{type:"punctuation.parenthesis.css"}:"@"!==e||this.inMeta?"}"===e&&this.inMeta?(this.inMeta=!1,this.nextState(m.Selector,{type:"punctuation.bracket.css"})):/[\*\(\)\[\]\+>=\~\|;]/.test(e)?{type:"punctuation.css"}:"#"===e?(t.advanceIfRegExp2(g),{type:c.TOKEN_SELECTOR+".id.css"}):"."===e?(t.advanceIfRegExp2(g),{type:c.TOKEN_SELECTOR+".class.css"}):(this.consumeIdent(t),{type:c.TOKEN_SELECTOR_TAG+".css"}):(t.advanceIfRegExp2(g),this.nextState(m.Meta,{type:c.TOKEN_AT_KEYWORD+".css"}));case m.Meta:if("{"===e){var n=m.Rule;return this.inMeta&&(n=m.Selector),this.nextState(n,{type:"punctuation.bracket.css"})}return"("===e||")"===e?{type:"punctuation.parenthesis.css"}:";"===e?(0===this.metaBraceCount&&(this.inMeta=!1),this.nextState(m.Selector,{type:"punctuation.css"})):"u"!==e&&"U"!==e||!t.advanceIfStringCaseInsensitive2("rl")?/[\*\(\)\[\]\+>=\~\|]/.test(e)?{type:"punctuation.css"}:(this.inMeta=!0,this.consumeIdent(t),{type:c.TOKEN_VALUE+".css"}):(t.advanceIfStringCaseInsensitive2("-prefix"),this.nextState(m.MetaPostUrl,{type:c.TOKEN_VALUE+".css"}));case m.Rule:return"}"===e?this.nextState(m.Selector,{type:"punctuation.bracket.css"}):":"===e?this.nextState(m.Value,{type:"punctuation.css"}):"("===e||")"===e?{type:"punctuation.parenthesis.css"}:(this.consumeIdent(t),{type:c.TOKEN_PROPERTY+".css"});case m.Value:if("}"===e)return this.nextState(m.Selector,{type:"punctuation.bracket.css"});if(";"===e)return this.nextState(m.Rule,{type:"punctuation.css"});if(("u"===e||"U"===e)&&t.advanceIfStringCaseInsensitive2("rl"))return this.nextState(m.ValuePostUrl,{type:c.TOKEN_VALUE+".css"});if("("===e||")"===e)return{type:"punctuation.parenthesis.css"};if(","===e)return{type:"punctuation.css"};if("#"===e)return t.advanceIfRegExp2(/^[\w]*/),{type:c.TOKEN_VALUE+".hex.css"};if(/\d/.test(e)||/-|\+/.test(e)&&!t.eos()&&/\d/.test(t.peek()))return t.advanceIfRegExp2(/^[\d\.]*/),this.nextState(m.Unit,{type:c.TOKEN_VALUE+".numeric.css"});if("!"===e)return{type:c.TOKEN_VALUE+".keyword.css"};if(("i"===e||"I"===e)&&t.advanceIfStringCaseInsensitive2("mportant"))return{type:c.TOKEN_VALUE+".keyword.css"};if(this.consumeIdent(t))return{type:c.TOKEN_VALUE+".css"};break;case m.Unit:return t.goBack(1),t.advanceIfRegExp2(/^(em|ex|ch|rem|vw|vh|vm|cm|mm|in|px|pt|pc|deg|grad|rad|turn|s|ms|Hz|kHz|%)/)?{type:c.TOKEN_VALUE+".unit.css"}:(this.nextState(m.Value,null),this.tokenize(t))}return{type:""}},e}(p.AbstractState);e.State=y;var k=function(t){function e(n,r,o){var i=this;t.call(this,n.id),this._modeWorkerManager=new u.ModeWorkerManager(n,"vs/languages/css/common/cssWorker","CSSWorker",null,r),this._threadService=o,this.tokenizationSupport=new f.TokenizationSupport(this,{getInitialState:function(){return new y(i,m.Selector,!1,null,!1,0)}},!1,!1),h.LanguageConfigurationRegistry.register(this.getId(),e.LANG_CONFIG),this.inplaceReplaceSupport=this,this.configSupport=this,s.DocumentHighlightProviderRegistry.register(this.getId(),{provideDocumentHighlights:function(t,e,n){return v.wireCancellationToken(n,i._provideDocumentHighlights(t.uri,e))}},!0),s.HoverProviderRegistry.register(this.getId(),{provideHover:function(t,e,n){return v.wireCancellationToken(n,i._provideHover(t.uri,e))}},!0),s.ReferenceProviderRegistry.register(this.getId(),{provideReferences:function(t,e,n,r){return v.wireCancellationToken(r,i._provideReferences(t.uri,e))}},!0),s.DocumentSymbolProviderRegistry.register(this.getId(),{provideDocumentSymbols:function(t,e){return v.wireCancellationToken(e,i._provideDocumentSymbols(t.uri))}},!0),s.DefinitionProviderRegistry.register(this.getId(),{provideDefinition:function(t,e,n){return v.wireCancellationToken(n,i._provideDefinition(t.uri,e))}},!0),s.SuggestRegistry.register(this.getId(),{triggerCharacters:[" ",":"],shouldAutotriggerSuggest:!0,provideCompletionItems:function(t,e,n){return v.wireCancellationToken(n,i._provideCompletionItems(t.uri,e))}},!0),s.CodeActionProviderRegistry.register(this.getId(),{provideCodeActions:function(t,e,n){return v.wireCancellationToken(n,i._provideCodeActions(t.uri,e))}},!0)}return n(e,t),e.prototype.creationDone=function(){this._threadService.isInMainThread&&this._pickAWorkerToValidate()},e.prototype._worker=function(t){return this._modeWorkerManager.worker(t)},e.prototype.configure=function(t){return this._threadService.isInMainThread?this._configureWorkers(t):this._worker(function(e){return e._doConfigure(t)})},e.prototype._configureWorkers=function(t){return this._worker(function(e){return e._doConfigure(t)})},e.prototype.navigateValueSet=function(t,e,n){return this._worker(function(r){return r.navigateValueSet(t,e,n)})},e.prototype._pickAWorkerToValidate=function(){return this._worker(function(t){return t.enableValidator()})},e.prototype._provideDocumentHighlights=function(t,e){return this._worker(function(n){return n.provideDocumentHighlights(t,e)})},e.prototype._provideCompletionItems=function(t,e){return this._worker(function(n){return n.provideCompletionItems(t,e)})},e.prototype._provideDefinition=function(t,e){return this._worker(function(n){return n.provideDefinition(t,e)})},e.prototype._provideHover=function(t,e){return this._worker(function(n){return n.provideHover(t,e)})},e.prototype._provideReferences=function(t,e){return this._worker(function(n){return n.provideReferences(t,e)})},e.prototype._provideDocumentSymbols=function(t){return this._worker(function(e){return e.provideDocumentSymbols(t)})},e.prototype.findColorDeclarations=function(t){return this._worker(function(e){return e.findColorDeclarations(t)})},e.prototype._provideCodeActions=function(t,e){return this._worker(function(n){return n.provideCodeActions(t,e)})},e.LANG_CONFIG={wordPattern:/(#?-?\d*\.\d\w*%?)|((::|[@#.!:])?[\w-?]+%?)|::|[@#.!:]/g,comments:{blockComment:["/*","*/"]},brackets:[["{","}"],["[","]"],["(",")"]],autoClosingPairs:[{open:"{",close:"}"},{open:"[",close:"]"},{open:"(",close:")"},{open:'"',close:'"',notIn:["string"]},{open:"'",close:"'",notIn:["string"]}]},e.$_configureWorkers=a.AllWorkersAttr(e,e.prototype._configureWorkers),e.$navigateValueSet=a.OneWorkerAttr(e,e.prototype.navigateValueSet),e.$_pickAWorkerToValidate=a.OneWorkerAttr(e,e.prototype._pickAWorkerToValidate,d.ThreadAffinity.Group1),e.$_provideDocumentHighlights=a.OneWorkerAttr(e,e.prototype._provideDocumentHighlights),e.$_provideCompletionItems=a.OneWorkerAttr(e,e.prototype._provideCompletionItems),e.$_provideDefinition=a.OneWorkerAttr(e,e.prototype._provideDefinition),e.$_provideHover=a.OneWorkerAttr(e,e.prototype._provideHover),e.$_provideReferences=a.OneWorkerAttr(e,e.prototype._provideReferences),e.$_provideDocumentSymbols=a.OneWorkerAttr(e,e.prototype._provideDocumentSymbols),e.$findColorDeclarations=a.OneWorkerAttr(e,e.prototype.findColorDeclarations),e._provideCodeActions=a.OneWorkerAttr(e,e.prototype._provideCodeActions),e=r([o(1,l.IInstantiationService),o(2,d.IThreadService)],e)}(u.AbstractMode);e.CSSMode=k})}).call(this);
//# sourceMappingURL=../../../../../min-maps/vs/languages/css/common/css.js.map