/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.2(1ebfb1b687c4345ac9c6da39051431a46c120a65)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var e=["exports","require","vs/languages/less/common/parser/lessScanner","vs/languages/css/common/parser/cssScanner","vs/languages/less/common/parser/lessParser","vs/nls!vs/languages/less/common/services/intelliSense","vs/languages/less/common/services/intelliSense","vs/languages/css/common/cssWorker","vs/languages/css/common/parser/cssParser","vs/nls","vs/nls!vs/languages/less/common/lessWorker","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/services/intelliSense","vs/languages/less/common/lessWorker","vs/languages/css/common/parser/cssErrors"],t=function(t){for(var i=[],r=0,n=t.length;n>r;r++)i[r]=e[t[r]];return i},i=this&&this.__extends||function(e,t){function i(){this.constructor=e}for(var r in t)t.hasOwnProperty(r)&&(e[r]=t[r]);e.prototype=null===t?Object.create(t):(i.prototype=t.prototype,new i)};define(e[2],t([1,0,3]),function(e,t,r){"use strict";var n="/".charCodeAt(0),a="\n".charCodeAt(0),s="\r".charCodeAt(0),o="\f".charCodeAt(0),l="`".charCodeAt(0),c=".".charCodeAt(0),p=r.TokenType.CustomToken;t.Ellipsis=p++;var h=function(e){function p(){e.apply(this,arguments)}return i(p,e),p.prototype.scan=function(){var i=this.trivia();if(null!==i)return i;var r=this.stream.pos(),n=this.escapedJavaScript();return null!==n?this.finishToken(r,n):this.stream.advanceIfChars([c,c,c])?this.finishToken(r,t.Ellipsis):e.prototype.scan.call(this)},p.prototype.comment=function(){return e.prototype.comment.call(this)?!0:this.stream.advanceIfChars([n,n])?(this.stream.advanceWhileChar(function(e){switch(e){case a:case s:case o:return!1;default:return!0}}),!0):!1},p.prototype.escapedJavaScript=function(){var e=this.stream.peekChar();return e===l?(this.stream.advance(1),this.stream.advanceWhileChar(function(e){return e!==l}),this.stream.advanceIfChar(l)?r.TokenType.EscapedJavaScript:r.TokenType.BadEscapedJavaScript):null},p}(r.Scanner);t.LessScanner=h}),define(e[4],t([1,0,2,3,8,11,14]),function(e,t,r,n,a,s,o){"use strict";var l=function(e){function t(){e.call(this,new r.LessScanner)}return i(t,e),t.prototype._parseStylesheetStatement=function(){return this._tryParseMixinDeclaration()||e.prototype._parseStylesheetStatement.call(this)||this._parseVariableDeclaration()},t.prototype._parseImport=function(){var e=this.create(s.Import);if(!this.accept(n.TokenType.AtKeyword,"@import")&&!this.accept(n.TokenType.AtKeyword,"@import-once"))return null;if(this.accept(n.TokenType.ParenthesisL)){if(!this.accept(n.TokenType.Ident))return this.finish(e,o.ParseError.IdentifierExpected,[n.TokenType.SemiColon]);if(!this.accept(n.TokenType.ParenthesisR))return this.finish(e,o.ParseError.RightParenthesisExpected,[n.TokenType.SemiColon])}return this.accept(n.TokenType.URI)||this.accept(n.TokenType.String)?(e.setMedialist(this._parseMediaList()),this.finish(e)):this.finish(e,o.ParseError.URIOrStringExpected,[n.TokenType.SemiColon])},t.prototype._parseMediaQuery=function(t){var i=e.prototype._parseMediaQuery.call(this,t);if(!i){var i=this.create(s.MediaQuery);return i.addChild(this._parseVariable())?this.finish(i):null}return i},t.prototype._parseVariableDeclaration=function(e){void 0===e&&(e=[]);var t=this.create(s.VariableDeclaration),i=this.mark();return t.setVariable(this._parseVariable())?this.accept(n.TokenType.Colon,":")?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?(this.peek(n.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)):this.finish(t,o.ParseError.VariableValueExpected,[],e)):(this.restoreAtMark(i),null):null},t.prototype._parseVariable=function(){for(var e=this.create(s.Variable),t=this.mark();this.accept(n.TokenType.Delim,"@");)if(this.hasWhitespace())return this.restoreAtMark(t),null;return this.accept(n.TokenType.AtKeyword)?e:(this.restoreAtMark(t),null)},t.prototype._parseTerm=function(){var t=e.prototype._parseTerm.call(this);return t?t:(t=this.create(s.Term),t.setExpression(this._parseVariable())||t.setExpression(this._parseEscaped())?this.finish(t):null)},t.prototype._parseEscaped=function(){var e=this.createNode(s.NodeType.EscapedValue);return this.accept(n.TokenType.EscapedJavaScript)||this.accept(n.TokenType.BadEscapedJavaScript)?this.finish(e):this.accept(n.TokenType.Delim,"~")?this.finish(e,this.accept(n.TokenType.String)?null:o.ParseError.TermExpected):null},t.prototype._parseOperator=function(){var t=this._parseGuardOperator();return t?t:e.prototype._parseOperator.call(this)},t.prototype._parseGuardOperator=function(){var e=this.createNode(s.NodeType.Operator);return this.accept(n.TokenType.Delim,">")?(this.accept(n.TokenType.Delim,"="),e):this.accept(n.TokenType.Delim,"=")?(this.accept(n.TokenType.Delim,"<"),e):this.accept(n.TokenType.Delim,"<")?e:null},t.prototype._parseRuleSetDeclaration=function(){return this.peek(n.TokenType.AtKeyword)?this._parseKeyframe()||this._parseMedia()||this._parseVariableDeclaration():this._tryParseMixinDeclaration()||this._tryParseRuleset(!0)||this._parseMixinReference()||this._parseExtend()||e.prototype._parseRuleSetDeclaration.call(this)},t.prototype._parseSimpleSelectorBody=function(){return this._parseSelectorCombinator()||e.prototype._parseSimpleSelectorBody.call(this)},t.prototype._parseSelectorCombinator=function(){var e=this.createNode(s.NodeType.SelectorCombinator);if(this.accept(n.TokenType.Delim,"&")){for(;!this.hasWhitespace()&&(this.accept(n.TokenType.Delim,"-")||e.addChild(this._parseIdent())||this.accept(n.TokenType.Delim,"&")););return this.finish(e)}return null},t.prototype._parseSelectorIdent=function(){return this._parseIdent()||this._parseSelectorInterpolation()},t.prototype._parseSelectorInterpolation=function(){var e=this.createNode(s.NodeType.SelectorInterpolation);return this.accept(n.TokenType.Delim,"~")?this.hasWhitespace()||!this.accept(n.TokenType.String)&&!this.accept(n.TokenType.BadString)?this.finish(e,o.ParseError.StringLiteralExpected):this.finish(e):this.accept(n.TokenType.Delim,"@")?this.hasWhitespace()||!this.accept(n.TokenType.CurlyL)?this.finish(e,o.ParseError.LeftCurlyExpected):e.addChild(this._parseIdent())?this.accept(n.TokenType.CurlyR)?this.finish(e):this.finish(e,o.ParseError.RightCurlyExpected):this.finish(e,o.ParseError.IdentifierExpected):null},t.prototype._tryParseMixinDeclaration=function(){if(!this.peek(n.TokenType.Delim,"."))return null;var e=this.mark(),t=this.create(s.MixinDeclaration);if(!t.setIdentifier(this._parseMixinDeclarationIdentifier())||!this.accept(n.TokenType.ParenthesisL))return this.restoreAtMark(e),null;if(t.getParameters().addChild(this._parseMixinParameter()))for(;this.accept(n.TokenType.Comma)||this.accept(n.TokenType.SemiColon);)if(!t.getParameters().addChild(this._parseMixinParameter()))return this.finish(t,o.ParseError.IdentifierExpected);return this.accept(n.TokenType.ParenthesisR)?(t.setGuard(this._parseGuard()),this.peek(n.TokenType.CurlyL)?this._parseBody(t,this._parseRuleSetDeclaration.bind(this)):(this.restoreAtMark(e),null)):this.finish(t,o.ParseError.RightParenthesisExpected)},t.prototype._parseMixinDeclarationIdentifier=function(){var e=this.create(s.Identifier);return this.consumeToken(),this.hasWhitespace()||!this.accept(n.TokenType.Ident)?null:(e.referenceTypes=[s.ReferenceType.Mixin],this.finish(e))},t.prototype._parseExtend=function(){if(!this.peek(n.TokenType.Delim,"&"))return null;var e=this.mark(),t=this.create(s.ExtendsReference);return this.consumeToken(),!this.hasWhitespace()&&this.accept(n.TokenType.Colon)&&this.accept(n.TokenType.Ident,"extend")?this.accept(n.TokenType.ParenthesisL)?t.setSelector(this._parseSimpleSelector())?this.accept(n.TokenType.ParenthesisR)?this.finish(t):this.finish(t,o.ParseError.RightParenthesisExpected):this.finish(t,o.ParseError.SelectorExpected):this.finish(t,o.ParseError.LeftParenthesisExpected):(this.restoreAtMark(e),null)},t.prototype._parseMixinReference=function(){if(!this.peek(n.TokenType.Delim,"."))return null;var e=this.create(s.MixinReference),t=this.create(s.Identifier);if(this.consumeToken(),this.hasWhitespace()||!this.accept(n.TokenType.Ident))return this.finish(e,o.ParseError.IdentifierExpected);if(e.setIdentifier(this.finish(t)),!this.hasWhitespace()&&this.accept(n.TokenType.ParenthesisL)){if(e.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(n.TokenType.Comma)||this.accept(n.TokenType.SemiColon);)if(!e.getArguments().addChild(this._parseExpr()))return this.finish(e,o.ParseError.ExpressionExpected);if(!this.accept(n.TokenType.ParenthesisR))return this.finish(e,o.ParseError.RightParenthesisExpected);t.referenceTypes=[s.ReferenceType.Mixin]}else t.referenceTypes=[s.ReferenceType.Mixin,s.ReferenceType.Rule];return e.addChild(this._parsePrio()),this.finish(e)},t.prototype._parseMixinParameter=function(){var e=this.create(s.FunctionParameter);if(this.peek(n.TokenType.AtKeyword,"@rest")){var t=this.create(s.Node);return this.consumeToken(),this.accept(r.Ellipsis)?(e.setIdentifier(this.finish(t)),this.finish(e)):this.finish(e,o.ParseError.DotExpected,[],[n.TokenType.Comma,n.TokenType.ParenthesisR])}if(this.peek(r.Ellipsis)){var i=this.create(s.Node);return this.consumeToken(),e.setIdentifier(this.finish(i)),this.finish(e)}return e.setIdentifier(this._parseVariable())&&this.accept(n.TokenType.Colon),e.setDefaultValue(this._parseExpr(!0)),this.finish(e)},t.prototype._parseGuard=function(){var e=this.create(s.LessGuard);if(!this.accept(n.TokenType.Ident,"when"))return null;if(e.isNegated=this.accept(n.TokenType.Ident,"not"),!e.getConditions().addChild(this._parseGuardCondition()))return this.finish(e,o.ParseError.ConditionExpected);for(;this.accept(n.TokenType.Ident,"and")||this.accept(n.TokenType.Comma,",");)if(!e.getConditions().addChild(this._parseGuardCondition()))return this.finish(e,o.ParseError.ConditionExpected);return this.finish(e)},t.prototype._parseGuardCondition=function(){var e=this.create(s.GuardCondition);return this.accept(n.TokenType.ParenthesisL)?(!e.addChild(this._parseExpr()),this.accept(n.TokenType.ParenthesisR)?this.finish(e):this.finish(e,o.ParseError.RightParenthesisExpected)):null},t.prototype._parseFunctionIdentifier=function(){if(this.peek(n.TokenType.Delim,"%")){var t=this.create(s.Identifier);return t.referenceTypes=[s.ReferenceType.Function],this.consumeToken(),this.finish(t)}return e.prototype._parseFunctionIdentifier.call(this)},t}(a.Parser);t.LessParser=l}),define(e[5],t([9,10]),function(e,t){return e.create("vs/languages/less/common/services/intelliSense",t)}),define(e[6],t([1,0,12,5]),function(e,t,r,n){"use strict";var a=function(e){function t(){e.call(this,"@")}return i(t,e),t.prototype.createFunctionProposals=function(e,t){return e.forEach(function(e){t.push({label:e.name,typeLabel:e.example,documentationLabel:e.description,codeSnippet:e.name+"({{}})",type:"function"})}),t},t.prototype.getTermProposals=function(i){return this.createFunctionProposals(t.builtInProposals,i),e.prototype.getTermProposals.call(this,i)},t.prototype.getColorProposals=function(i,r){return this.createFunctionProposals(t.colorProposals,r),e.prototype.getColorProposals.call(this,i,r)},t.builtInProposals=[{name:"escape",example:"escape(@string);",description:n.localize(0,null)},{name:"e",example:"e(@string);",description:n.localize(1,null)},{name:"replace",example:"replace(@string, @pattern, @replacement[, @flags]);",description:n.localize(2,null)},{name:"unit",example:"unit(@dimension, [@unit: '']);",description:n.localize(3,null)},{name:"color",example:"color(@string);",description:n.localize(4,null)},{name:"convert",example:"convert(@value, unit);",description:n.localize(5,null)},{name:"data-uri",example:"data-uri([mimetype,] url);",description:n.localize(6,null)},{name:"length",example:"length(@list);",description:n.localize(7,null)},{name:"extract",example:"extract(@list, index);",description:n.localize(8,null)},{name:"abs",description:n.localize(9,null),example:"abs(number);"},{name:"acos",description:n.localize(10,null),example:"acos(number);"},{name:"asin",description:n.localize(11,null),example:"asin(number);"},{name:"ceil",example:"ceil(@number);",description:n.localize(12,null)},{name:"cos",description:n.localize(13,null),example:"cos(number);"},{name:"floor",description:n.localize(14,null),example:"floor(@number);"},{name:"percentage",description:n.localize(15,null),example:"percentage(@number);"},{name:"round",description:n.localize(16,null),example:"round(number, [places: 0]);"},{name:"sqrt",description:n.localize(17,null),example:"sqrt(number);"},{name:"sin",description:n.localize(18,null),example:"sin(number);"},{name:"tan",description:n.localize(19,null),example:"tan(number);"},{name:"atan",description:n.localize(20,null),example:"atan(number);"},{name:"pi",description:n.localize(21,null),example:"pi();"},{name:"pow",description:n.localize(22,null),example:"pow(@base, @exponent);"},{name:"mod",description:n.localize(23,null),example:"mod(number, number);"},{name:"min",description:n.localize(24,null),example:"min(@x, @y);"},{name:"max",description:n.localize(25,null),example:"max(@x, @y);"}],t.colorProposals=[{name:"argb",example:"argb(@color);",description:n.localize(26,null)},{name:"hsl",example:"hsl(@hue, @saturation, @lightness);",description:n.localize(27,null)},{name:"hsla",example:"hsla(@hue, @saturation, @lightness, @alpha);",description:n.localize(28,null)},{name:"hsv",example:"hsv(@hue, @saturation, @value);",description:n.localize(29,null)},{name:"hsva",example:"hsva(@hue, @saturation, @value, @alpha);",description:n.localize(30,null)},{name:"hue",example:"hue(@color);",description:n.localize(31,null)},{name:"saturation",example:"saturation(@color);",description:n.localize(32,null)},{name:"lightness",example:"lightness(@color);",description:n.localize(33,null)},{name:"hsvhue",example:"hsvhue(@color);",description:n.localize(34,null)},{name:"hsvsaturation",example:"hsvsaturation(@color);",description:n.localize(35,null)},{name:"hsvvalue",example:"hsvvalue(@color);",description:n.localize(36,null)},{name:"red",example:"red(@color);",description:n.localize(37,null)},{name:"green",example:"green(@color);",description:n.localize(38,null)},{name:"blue",example:"blue(@color);",description:n.localize(39,null)},{name:"alpha",example:"alpha(@color);",description:n.localize(40,null)},{name:"luma",example:"luma(@color);",description:n.localize(41,null)},{name:"saturate",example:"saturate(@color, 10%);",description:n.localize(42,null)},{name:"desaturate",example:"desaturate(@color, 10%);",description:n.localize(43,null)},{name:"lighten",example:"lighten(@color, 10%);",description:n.localize(44,null)},{name:"darken",example:"darken(@color, 10%);",description:n.localize(45,null)},{name:"fadein",example:"fadein(@color, 10%);",description:n.localize(46,null)},{name:"fadeout",example:"fadeout(@color, 10%);",description:n.localize(47,null)},{name:"fade",example:"fade(@color, 50%);",description:n.localize(48,null)},{name:"spin",example:"spin(@color, 10);",description:n.localize(49,null)},{name:"mix",example:"mix(@color1, @color2, [@weight: 50%]);",description:n.localize(50,null)},{name:"greyscale",example:"greyscale(@color);",description:n.localize(51,null)},{name:"contrast",example:"contrast(@color1, [@darkcolor: black], [@lightcolor: white], [@threshold: 43%]);",description:n.localize(52,null)},{name:"multiply",example:"multiply(@color1, @color2);"},{name:"screen",example:"screen(@color1, @color2);"},{name:"overlay",example:"overlay(@color1, @color2);"},{name:"softlight",example:"softlight(@color1, @color2);"},{name:"hardlight",example:"hardlight(@color1, @color2);"},{name:"difference",example:"difference(@color1, @color2);"},{name:"exclusion",example:"exclusion(@color1, @color2);"},{name:"average",example:"average(@color1, @color2);"},{name:"negation",example:"negation(@color1, @color2);"}],t}(r.CSSIntellisense);t.LESSIntellisense=a}),define(e[13],t([1,0,7,4,6]),function(e,t,r,n,a){"use strict";var s=function(e){function t(){e.apply(this,arguments)}return i(t,e),t.prototype.createIntellisense=function(){return new a.LESSIntellisense},t.prototype.createParser=function(){return new n.LessParser},t}(r.CSSWorker);t.LessWorker=s})}).call(this);
//# sourceMappingURL=../../../../../min-maps/vs/languages/less/common/lessWorker.js.map