/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.4.2(1ebfb1b687c4345ac9c6da39051431a46c120a65)
 * Released under the MIT license
 * https://github.com/Microsoft/vscode/blob/master/LICENSE.txt
 *-----------------------------------------------------------*/
(function(){var e=["exports","require","vs/languages/sass/common/parser/sassParser","vs/languages/css/common/parser/cssScanner","vs/nls!vs/languages/sass/common/parser/sassErrors","vs/nls","vs/nls!vs/languages/sass/common/sassWorker","vs/languages/sass/common/parser/sassErrors","vs/languages/sass/common/parser/sassScanner","vs/languages/sass/common/services/intelliSense","vs/nls!vs/languages/sass/common/services/intelliSense","vs/languages/css/common/parser/cssErrors","vs/languages/css/common/parser/cssNodes","vs/languages/css/common/parser/cssParser","vs/languages/css/common/services/intelliSense","vs/languages/sass/common/sassWorker","vs/languages/css/common/cssWorker"],t=function(t){for(var r=[],s=0,n=t.length;n>s;s++)r[s]=e[t[s]];return r},r=this&&this.__extends||function(e,t){function r(){this.constructor=e}for(var s in t)t.hasOwnProperty(s)&&(e[s]=t[s]);e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)};define(e[8],t([1,0,3]),function(e,t,s){"use strict";var n="/".charCodeAt(0),i="\n".charCodeAt(0),a="\r".charCodeAt(0),o="\f".charCodeAt(0),l="$".charCodeAt(0),c="#".charCodeAt(0),p="{".charCodeAt(0),u="=".charCodeAt(0),h="!".charCodeAt(0),f="<".charCodeAt(0),d=">".charCodeAt(0),y=".".charCodeAt(0),m=s.TokenType.CustomToken;t.VariableName=m++,t.InterpolationFunction=m++,t.Default=m++,t.EqualsOperator=m++,t.NotEqualsOperator=m++,t.GreaterEqualsOperator=m++,t.SmallerEqualsOperator=m++,t.Ellipsis=m++;var T=function(e){function m(){e.apply(this,arguments)}return r(m,e),m.prototype.scan=function(){var r=this.trivia();if(null!==r)return r;var n=this.stream.pos();if(this.stream.advanceIfChar(l)){var i=["$"];if(this.ident(i))return this.finishToken(n,t.VariableName,i.join(""));this.stream.goBackTo(n)}return this.stream.advanceIfChars([c,p])?this.finishToken(n,t.InterpolationFunction):this.stream.advanceIfChars([u,u])?this.finishToken(n,t.EqualsOperator):this.stream.advanceIfChars([h,u])?this.finishToken(n,t.NotEqualsOperator):this.stream.advanceIfChar(f)?this.stream.advanceIfChar(u)?this.finishToken(n,t.SmallerEqualsOperator):this.finishToken(n,s.TokenType.Delim):this.stream.advanceIfChar(d)?this.stream.advanceIfChar(u)?this.finishToken(n,t.GreaterEqualsOperator):this.finishToken(n,s.TokenType.Delim):this.stream.advanceIfChars([y,y,y])?this.finishToken(n,t.Ellipsis):e.prototype.scan.call(this)},m.prototype.comment=function(){return e.prototype.comment.call(this)?!0:this.stream.advanceIfChars([n,n])?(this.stream.advanceWhileChar(function(e){switch(e){case i:case a:case o:return!1;default:return!0}}),!0):!1},m}(s.Scanner);t.SassScanner=T}),define(e[4],t([5,6]),function(e,t){return e.create("vs/languages/sass/common/parser/sassErrors",t)}),define(e[7],t([1,0,4]),function(e,t,r){"use strict";var s=function(){function e(e,t){this.id=e,this.message=t}return e}();t.SassIssueType=s,t.ParseError={FromExpected:new s("sass-fromexpected",r.localize(0,null)),ThroughOrToExpected:new s("sass-throughexpected",r.localize(1,null)),InExpected:new s("sass-fromexpected",r.localize(2,null))}}),define(e[2],t([1,0,8,7,3,13,12,11]),function(e,t,s,n,i,a,o,l){"use strict";var c=function(e){function t(){e.call(this,new s.SassScanner)}return r(t,e),t.prototype._parseStylesheetStatement=function(){return e.prototype._parseStylesheetStatement.call(this)||this._parseVariableDeclaration()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseMixinDeclaration()||this._parseMixinContent()||this._parseMixinReference()||this._parseFunctionDeclaration()},t.prototype._parseImport=function(){var e=this.create(o.Import);if(!this.accept(i.TokenType.AtKeyword,"@import"))return null;if(!this.accept(i.TokenType.URI)&&!this.accept(i.TokenType.String))return this.finish(e,l.ParseError.URIOrStringExpected);for(;this.accept(i.TokenType.Comma);)if(!this.accept(i.TokenType.URI)&&!this.accept(i.TokenType.String))return this.finish(e,l.ParseError.URIOrStringExpected);return e.setMedialist(this._parseMediaList()),this.finish(e)},t.prototype._parseVariableDeclaration=function(e){void 0===e&&(e=[]);var t=this.create(o.VariableDeclaration);return t.setVariable(this._parseVariable())?this.accept(i.TokenType.Colon,":")?(t.colonPosition=this.prevToken.offset,t.setValue(this._parseExpr())?this.accept(i.TokenType.Exclamation)&&!this.accept(i.TokenType.Ident,"default",!0)?this.finish(t,l.ParseError.UnknownKeyword):(this.peek(i.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)):this.finish(t,l.ParseError.VariableValueExpected,[],e)):this.finish(t,l.ParseError.ColonExpected):null},t.prototype._parseMediaFeatureName=function(){return this._parseFunction()||this._parseIdent()||this._parseVariable()},t.prototype._parseKeyframeSelector=function(){return e.prototype._parseKeyframeSelector.call(this)||this._parseMixinContent()},t.prototype._parseVariable=function(){var e=this.create(o.Variable);return this.accept(s.VariableName)?e:null},t.prototype._parseIdent=function(e){var t=this.create(o.Identifier);t.referenceTypes=e;for(var r=!1;(this.accept(i.TokenType.Ident)||t.addChild(this._parseInterpolation()))&&(r=!0,!this.hasWhitespace()&&this.accept(i.TokenType.Delim,"-"),!this.hasWhitespace()););return r?this.finish(t):null},t.prototype._parseTerm=function(){var t=e.prototype._parseTerm.call(this);return t?t:(t=this.create(o.Term),t.setExpression(this._parseVariable())?this.finish(t):null)},t.prototype._parseInterpolation=function(){var e=this.create(o.Interpolation);return this.accept(s.InterpolationFunction)?e.addChild(this._parseBinaryExpr())?this.accept(i.TokenType.CurlyR)?this.finish(e):this.finish(e,l.ParseError.RightCurlyExpected):this.finish(e,l.ParseError.ExpressionExpected):null},t.prototype._parseOperator=function(){var t=this.createNode(o.NodeType.Operator);if(this.peek(s.EqualsOperator)||this.peek(s.NotEqualsOperator)||this.peek(s.GreaterEqualsOperator)||this.peek(s.SmallerEqualsOperator)||this.peek(i.TokenType.Delim,">")||this.peek(i.TokenType.Delim,"<")||this.peek(i.TokenType.Ident,"and")||this.peek(i.TokenType.Ident,"or")||this.peek(i.TokenType.Delim,"%")){var t=this.createNode(o.NodeType.Operator);return this.consumeToken(),this.finish(t)}return e.prototype._parseOperator.call(this)},t.prototype._parseUnaryOperator=function(){if(this.peek(i.TokenType.Ident,"not")){var t=this.create(o.Node);return this.consumeToken(),this.finish(t)}return e.prototype._parseUnaryOperator.call(this)},t.prototype._parseRuleSetDeclaration=function(){return this.peek(i.TokenType.AtKeyword)?this._parseKeyframe()||this._parseImport()||this._parseMedia()||this._parseFontFace()||this._parseWarnAndDebug()||this._parseControlStatement()||this._parseFunctionDeclaration()||this._parseExtends()||this._parseMixinReference()||this._parseMixinContent()||this._parseMixinDeclaration():this._parseVariableDeclaration()||this._tryParseRuleset(!0)||e.prototype._parseRuleSetDeclaration.call(this)},t.prototype._parseDeclaration=function(e){var t=this.create(o.Declaration);if(!t.setProperty(this._parseProperty()))return null;if(!this.accept(i.TokenType.Colon,":"))return this.finish(t,l.ParseError.ColonExpected,[i.TokenType.Colon],e);t.colonPosition=this.prevToken.offset;var r=!1;if(t.setValue(this._parseExpr())&&(r=!0,t.addChild(this._parsePrio())),this.peek(i.TokenType.CurlyL))t.setNestedProperties(this._parseNestedProperties());else if(!r)return this.finish(t,l.ParseError.PropertyValueExpected);return this.peek(i.TokenType.SemiColon)&&(t.semicolonPosition=this.token.offset),this.finish(t)},t.prototype._parseNestedProperties=function(){var e=this.create(o.NestedProperties);return this._parseBody(e,this._parseDeclaration.bind(this))},t.prototype._parseExtends=function(){var e=this.create(o.ExtendsReference);return this.accept(i.TokenType.AtKeyword,"@extend")?e.setSelector(this._parseSimpleSelector())?this.accept(i.TokenType.Exclamation)&&!this.accept(i.TokenType.Ident,"optional",!0)?this.finish(e,l.ParseError.UnknownKeyword):this.finish(e):this.finish(e,l.ParseError.SelectorExpected):null},t.prototype._parseSimpleSelectorBody=function(){return this._parseSelectorCombinator()||this._parseSelectorPlaceholder()||e.prototype._parseSimpleSelectorBody.call(this)},t.prototype._parseSelectorCombinator=function(){var e=this.createNode(o.NodeType.SelectorCombinator);if(this.accept(i.TokenType.Delim,"&")){for(;!this.hasWhitespace()&&(this.accept(i.TokenType.Delim,"-")||e.addChild(this._parseIdent())||this.accept(i.TokenType.Delim,"&")););return this.finish(e)}return null},t.prototype._parseSelectorPlaceholder=function(){var e=this.createNode(o.NodeType.SelectorPlaceholder);return this.accept(i.TokenType.Delim,"%")?(this._parseIdent(),this.finish(e)):null},t.prototype._parseWarnAndDebug=function(){if(!this.peek(i.TokenType.AtKeyword,"@debug")&&!this.peek(i.TokenType.AtKeyword,"@warn"))return null;var e=this.createNode(o.NodeType.Debug);return this.consumeToken(),e.addChild(this._parseExpr()),this.finish(e)},t.prototype._parseControlStatement=function(e){return void 0===e&&(e=this._parseRuleSetDeclaration.bind(this)),this.peek(i.TokenType.AtKeyword)?this._parseIfStatement(e)||this._parseForStatement(e)||this._parseEachStatement(e)||this._parseWhileStatement(e):null},t.prototype._parseIfStatement=function(e){return this.peek(i.TokenType.AtKeyword,"@if")?this._internalParseIfStatement(e):null},t.prototype._internalParseIfStatement=function(e){var t=this.create(o.IfStatement);if(this.consumeToken(),!t.setExpression(this._parseBinaryExpr()))return this.finish(t,l.ParseError.ExpressionExpected);if(this._parseBody(t,e),this.accept(i.TokenType.AtKeyword,"@else"))if(this.peek(i.TokenType.Ident,"if"))t.setElseClause(this._internalParseIfStatement(e));else if(this.peek(i.TokenType.CurlyL)){var r=this.create(o.ElseStatement);this._parseBody(r,e),t.setElseClause(r)}return this.finish(t)},t.prototype._parseForStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@for"))return null;var t=this.create(o.ForStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(i.TokenType.Ident,"from")?t.addChild(this._parseBinaryExpr())?this.accept(i.TokenType.Ident,"to")||this.accept(i.TokenType.Ident,"through")?t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,l.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,n.ParseError.ThroughOrToExpected,[i.TokenType.CurlyR]):this.finish(t,l.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,n.ParseError.FromExpected,[i.TokenType.CurlyR]):this.finish(t,l.ParseError.VariableNameExpected,[i.TokenType.CurlyR])},t.prototype._parseEachStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@each"))return null;var t=this.create(o.EachStatement);return this.consumeToken(),t.setVariable(this._parseVariable())?this.accept(i.TokenType.Ident,"in")?t.addChild(this._parseExpr())?this._parseBody(t,e):this.finish(t,l.ParseError.ExpressionExpected,[i.TokenType.CurlyR]):this.finish(t,n.ParseError.InExpected,[i.TokenType.CurlyR]):this.finish(t,l.ParseError.VariableNameExpected,[i.TokenType.CurlyR])},t.prototype._parseWhileStatement=function(e){if(!this.peek(i.TokenType.AtKeyword,"@while"))return null;var t=this.create(o.WhileStatement);return this.consumeToken(),t.addChild(this._parseBinaryExpr())?this._parseBody(t,e):this.finish(t,l.ParseError.ExpressionExpected,[i.TokenType.CurlyR])},t.prototype._parseFunctionBodyDeclaration=function(){return this._parseVariableDeclaration()||this._parseReturnStatement()||this._parseControlStatement(this._parseFunctionBodyDeclaration.bind(this))},t.prototype._parseFunctionDeclaration=function(){if(!this.peek(i.TokenType.AtKeyword,"@function"))return null;var e=this.create(o.FunctionDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Function])))return this.finish(e,l.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(!this.accept(i.TokenType.ParenthesisL))return this.finish(e,l.ParseError.LeftParenthesisExpected,[i.TokenType.CurlyR]);if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(i.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,l.ParseError.VariableNameExpected);return this.accept(i.TokenType.ParenthesisR)?this._parseBody(e,this._parseFunctionBodyDeclaration.bind(this)):this.finish(e,l.ParseError.RightParenthesisExpected,[i.TokenType.CurlyR])},t.prototype._parseReturnStatement=function(){if(!this.peek(i.TokenType.AtKeyword,"@return"))return null;var e=this.createNode(o.NodeType.ReturnStatement);return this.consumeToken(),e.addChild(this._parseExpr())?this.finish(e):this.finish(e,l.ParseError.ExpressionExpected)},t.prototype._parseMixinDeclaration=function(){if(!this.peek(i.TokenType.AtKeyword,"@mixin"))return null;var e=this.create(o.MixinDeclaration);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Mixin])))return this.finish(e,l.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(this.accept(i.TokenType.ParenthesisL)){if(e.getParameters().addChild(this._parseParameterDeclaration()))for(;this.accept(i.TokenType.Comma);)if(!e.getParameters().addChild(this._parseParameterDeclaration()))return this.finish(e,l.ParseError.VariableNameExpected);if(!this.accept(i.TokenType.ParenthesisR))return this.finish(e,l.ParseError.RightParenthesisExpected,[i.TokenType.CurlyR])}return this._parseBody(e,this._parseRuleSetDeclaration.bind(this))},t.prototype._parseParameterDeclaration=function(){var e=this.create(o.FunctionParameter);return e.setIdentifier(this._parseVariable())?(this.accept(s.Ellipsis),this.accept(i.TokenType.Colon)&&!e.setDefaultValue(this._parseExpr(!0))?this.finish(e,l.ParseError.VariableValueExpected,[],[i.TokenType.Comma,i.TokenType.ParenthesisR]):this.finish(e)):null},t.prototype._parseMixinContent=function(){if(!this.peek(i.TokenType.AtKeyword,"@content"))return null;var e=this.createNode(o.NodeType.MixinContent);return this.consumeToken(),this.finish(e)},t.prototype._parseMixinReference=function(){if(!this.peek(i.TokenType.AtKeyword,"@include"))return null;var e=this.create(o.MixinReference);if(this.consumeToken(),!e.setIdentifier(this._parseIdent([o.ReferenceType.Mixin])))return this.finish(e,l.ParseError.IdentifierExpected,[i.TokenType.CurlyR]);if(this.accept(i.TokenType.ParenthesisL)){if(e.getArguments().addChild(this._parseFunctionArgument()))for(;this.accept(i.TokenType.Comma);)if(!e.getArguments().addChild(this._parseFunctionArgument()))return this.finish(e,l.ParseError.ExpressionExpected);if(!this.accept(i.TokenType.ParenthesisR))return this.finish(e,l.ParseError.RightParenthesisExpected)}if(this.peek(i.TokenType.CurlyL)){var t=this.create(o.BodyDeclaration);this._parseBody(t,this._parseMixinReferenceBodyStatement.bind(this)),e.setContent(t)}return this.finish(e)},t.prototype._parseMixinReferenceBodyStatement=function(){return this._parseRuleSetDeclaration()||this._parseKeyframeSelector()},t.prototype._parseFunctionArgument=function(){var e=this.create(o.FunctionArgument),t=this.mark(),r=this._parseVariable();if(r)if(this.accept(i.TokenType.Colon))e.setIdentifier(r);else{if(this.accept(s.Ellipsis))return e.setValue(r),this.finish(e);this.restoreAtMark(t)}return e.setValue(this._parseExpr(!0))?this.finish(e):null},t}(a.Parser);t.SassParser=c}),define(e[10],t([5,6]),function(e,t){return e.create("vs/languages/sass/common/services/intelliSense",t)}),define(e[9],t([1,0,14,10]),function(e,t,s,n){"use strict";var i=function(e){function t(){e.call(this,"$")}return r(t,e),t.prototype.createFunctionProposals=function(e,r){var s=function(e,r){return r+": {{"+(t.variableDefaults[r]||"")+"}}"};return e.forEach(function(e){r.push({label:e.func.substr(0,e.func.indexOf("(")),typeLabel:e.func,documentationLabel:e.desc,codeSnippet:e.func.replace(/\[?(\$\w+)\]?/g,s),type:"function"})}),r},t.prototype.getCompletionsForSelector=function(r,s){return this.createFunctionProposals(t.selectorFuncs,s),e.prototype.getCompletionsForSelector.call(this,r,s)},t.prototype.getTermProposals=function(r){return this.createFunctionProposals(t.builtInFuncs,r),e.prototype.getTermProposals.call(this,r)},t.prototype.getColorProposals=function(r,s){return this.createFunctionProposals(t.colorProposals,s),e.prototype.getColorProposals.call(this,r,s)},t.prototype.getCompletionsForDeclarationProperty=function(t){return this.getCompletionsForSelector(null,t),e.prototype.getCompletionsForDeclarationProperty.call(this,t)},t.variableDefaults={$red:"1",$green:"2",$blue:"3",$alpha:"1.0",$color:"$color",$weight:"0.5",$hue:"0",$saturation:"0%",$lightness:"0%",$degrees:"0",$amount:"0",$string:'""',$substring:'"s"',$number:"0",$limit:"1"},t.colorProposals=[{func:"red($color)",desc:n.localize(0,null)},{func:"green($color)",desc:n.localize(1,null)},{func:"blue($color)",desc:n.localize(2,null)},{func:"mix($color, $color, [$weight])",desc:n.localize(3,null)},{func:"hue($color)",desc:n.localize(4,null)},{func:"saturation($color)",desc:n.localize(5,null)},{func:"lightness($color)",desc:n.localize(6,null)},{func:"adjust-hue($color, $degrees)",desc:n.localize(7,null)},{func:"lighten($color, $amount)",desc:n.localize(8,null)},{func:"darken($color, $amount)",desc:n.localize(9,null)},{func:"saturate($color, $amount)",desc:n.localize(10,null)},{func:"desaturate($color, $amount)",desc:n.localize(11,null)},{func:"grayscale($color)",desc:n.localize(12,null)},{func:"complement($color)",desc:n.localize(13,null)},{func:"invert($color)",desc:n.localize(14,null)},{func:"alpha($color)",desc:n.localize(15,null)},{func:"opacity($color)",desc:"Gets the alpha component (opacity) of a color."},{func:"rgba($color, $alpha)",desc:n.localize(16,null)},{func:"opacify($color, $amount)",desc:n.localize(17,null)},{func:"fade-in($color, $amount)",desc:n.localize(18,null)},{func:"transparentize($color, $amount) / fade-out($color, $amount)",desc:n.localize(19,null)},{func:"adjust-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:n.localize(20,null)},{func:"scale-color($color, [$red], [$green], [$blue], [$saturation], [$lightness], [$alpha])",desc:n.localize(21,null)},{func:"change-color($color, [$red], [$green], [$blue], [$hue], [$saturation], [$lightness], [$alpha])",desc:n.localize(22,null)},{func:"ie-hex-str($color)",desc:n.localize(23,null)}],t.selectorFuncs=[{func:"selector-nest($selectors…)",desc:n.localize(24,null)},{func:"selector-append($selectors…)",desc:n.localize(25,null)},{func:"selector-extend($selector, $extendee, $extender)",desc:n.localize(26,null)},{func:"selector-replace($selector, $original, $replacement)",desc:n.localize(27,null)},{func:"selector-unify($selector1, $selector2)",desc:n.localize(28,null)},{func:"is-superselector($super, $sub)",desc:n.localize(29,null)},{func:"simple-selectors($selector)",desc:n.localize(30,null)},{func:"selector-parse($selector)",desc:n.localize(31,null)}],t.builtInFuncs=[{func:"unquote($string)",desc:n.localize(32,null)},{func:"quote($string)",desc:n.localize(33,null)},{func:"str-length($string)",desc:n.localize(34,null)},{func:"str-insert($string, $insert, $index)",desc:n.localize(35,null)},{func:"str-index($string, $substring)",desc:n.localize(36,null)},{func:"str-slice($string, $start-at, [$end-at])",desc:n.localize(37,null)},{func:"to-upper-case($string)",desc:n.localize(38,null)},{func:"to-lower-case($string)",desc:n.localize(39,null)},{func:"percentage($number)",desc:n.localize(40,null)},{func:"round($number)",desc:n.localize(41,null)},{func:"ceil($number)",desc:n.localize(42,null)},{func:"floor($number)",desc:n.localize(43,null)},{func:"abs($number)",desc:n.localize(44,null)},{func:"min($numbers)",desc:n.localize(45,null)},{func:"max($numbers)",desc:n.localize(46,null)},{func:"random([$limit])",desc:n.localize(47,null)},{func:"length($list)",desc:n.localize(48,null)},{func:"nth($list, $n)",desc:n.localize(49,null)},{func:"set-nth($list, $n, $value)",desc:n.localize(50,null)},{func:"join($list1, $list2, [$separator])",desc:n.localize(51,null)},{func:"append($list1, $val, [$separator])",desc:n.localize(52,null)},{func:"zip($lists)",desc:n.localize(53,null)},{func:"index($list, $value)",desc:n.localize(54,null)},{func:"list-separator(#list)",desc:n.localize(55,null)},{func:"map-get($map, $key)",desc:n.localize(56,null)},{func:"map-merge($map1, $map2)",desc:n.localize(57,null)},{func:"map-remove($map, $keys)",desc:n.localize(58,null)},{func:"map-keys($map)",desc:n.localize(59,null)},{func:"map-values($map)",desc:n.localize(60,null)},{func:"map-has-key($map, $key)",desc:n.localize(61,null)},{func:"keywords($args)",desc:n.localize(62,null)},{func:"feature-exists($feature)",desc:n.localize(63,null)},{func:"variable-exists($name)",desc:n.localize(64,null)},{func:"global-variable-exists($name)",desc:n.localize(65,null)},{func:"function-exists($name)",desc:n.localize(66,null)},{func:"mixin-exists($name)",desc:n.localize(67,null)},{func:"inspect($value)",desc:n.localize(68,null)},{func:"type-of($value)",desc:n.localize(69,null)},{func:"unit($number)",desc:n.localize(70,null)},{func:"unitless($number)",desc:n.localize(71,null)},{func:"comparable($number1, $number2)",desc:n.localize(72,null)},{func:"call($name, $args…)",desc:n.localize(73,null)}],t}(s.CSSIntellisense);t.SASSIntellisense=i}),define(e[15],t([1,0,16,2,9]),function(e,t,s,n,i){"use strict";var a=function(e){function t(){e.apply(this,arguments)}return r(t,e),t.prototype.createIntellisense=function(){return new i.SASSIntellisense},t.prototype.createParser=function(){return new n.SassParser},t}(s.CSSWorker);t.SassWorker=a})}).call(this);
//# sourceMappingURL=../../../../../min-maps/vs/languages/sass/common/sassWorker.js.map